// Source code Copyright (C) 2006 by Clifford A. Shaffer.

// Test program for KDtree

#include <iostream>
using namespace std;

#include "book.h"

class CityRec {
private:
  char* myname;
  int mypos[2];
public:
  // Constructor
  CityRec(int x, int y, char *inname) {
    mypos[0] = x;
    mypos[1] = y;
    myname = inname;
  }
  ~CityRec() {delete myname; }
  char* name() { return myname; }
  int* coord() { return mypos; }
};

// Overload << operator to print City records
ostream& operator << (ostream& s, CityRec* p) {
  return s << p->name() << ", " << (p->coord())[0] << ", "
           << (p->coord())[1];
}


#include "binnode.ht"

#include "kdtree.h"

int main(int argc, char** argv) {
  CityRec *getCity;
  CityRec *getCity2;
  int coord[2];

  KD<CityRec*>* tree = new KD<CityRec*>(2);

  tree->insert(new CityRec(10, 20, "Acity"));
  tree->print();

  coord[0] = 10; coord[1] = 20;
  tree->remove(coord, getCity2);
  cout << getCity2 << endl;
  tree->print();

  // Insert records for the book example
  tree->insert(new CityRec(40, 45, "A"));
  tree->insert(new CityRec(70, 10, "C"));
  tree->insert(new CityRec(69, 50, "D"));
  tree->insert(new CityRec(15, 70, "B"));
  tree->insert(new CityRec(80, 90, "F"));
  tree->insert(new CityRec(55, 80, "E"));
  tree->print();

  cout << endl << "Do a regionsearch: 80, 90, 0\n";
  coord[0] = 80; coord[1] = 90;
  tree->regionsearch(coord, 0);

  cout << endl << "Do a regionsearch: 25, 65, 25\n";
  coord[0] = 25; coord[1] = 65;
  tree->regionsearch(coord, 25);

  cout << endl << "Now for delete tests" << endl;
  tree->insert(new CityRec(56, 20, "G"));
  tree->insert(new CityRec(57, 25, "H"));
  tree->print();

  coord[0] = 40; coord[1] = 45;
  tree->remove(coord, getCity);
  tree->print();
  return(0);
}
